<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLApiVertex&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#pro-static-attribs">Static Protected Attributes</a> &#124;
<a href="classTIGLApiVertex-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLApiVertex&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__interface__engine.html">Interface</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Core vertex class for the TIGL Engine (with only output edge buffer).  
 <a href="classTIGLApiVertex.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglApiVertex_8hpp_source.html">tiglApiVertex.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for TIGLApiVertex&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classTIGLApiVertex.png" usemap="#TIGLApiVertex&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;_map" alt=""/>
  <map id="TIGLApiVertex&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;_map" name="TIGLApiVertex&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;_map">
<area href="classTIGLContainersVertexBase.html" title="Core vertex class. " alt="TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;" shape="rect" coords="0,0,508,24"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a396f16eeb0b3b320cb8486f96fb84b87"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a396f16eeb0b3b320cb8486f96fb84b87">TIGLApiVertex</a> (IdType key, bool noMessageFlag, bool inFlagReactivate)</td></tr>
<tr class="memdesc:a396f16eeb0b3b320cb8486f96fb84b87"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor setting parameters.  <a href="#a396f16eeb0b3b320cb8486f96fb84b87">More...</a><br /></td></tr>
<tr class="separator:a396f16eeb0b3b320cb8486f96fb84b87"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0c21ec2a0ed8a52afb7617792c919d1d"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a0c21ec2a0ed8a52afb7617792c919d1d">TIGLApiVertex</a> (IdType key, DataType data, AlgDataType alg, bool noMessageFlag=false, bool inFlagReactivate=true)</td></tr>
<tr class="memdesc:a0c21ec2a0ed8a52afb7617792c919d1d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded constructor with more detailed setting parameters.  <a href="#a0c21ec2a0ed8a52afb7617792c919d1d">More...</a><br /></td></tr>
<tr class="separator:a0c21ec2a0ed8a52afb7617792c919d1d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad473daccad90e41fa3b6475ac3a2a481"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#ad473daccad90e41fa3b6475ac3a2a481">TIGLApiVertex</a> (IdType key)</td></tr>
<tr class="memdesc:ad473daccad90e41fa3b6475ac3a2a481"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded constructor with less detailed setting parameters.  <a href="#ad473daccad90e41fa3b6475ac3a2a481">More...</a><br /></td></tr>
<tr class="separator:ad473daccad90e41fa3b6475ac3a2a481"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0447a45606db0e53ae9d32801e050a06"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0447a45606db0e53ae9d32801e050a06"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a0447a45606db0e53ae9d32801e050a06">TIGLApiVertex</a> ()</td></tr>
<tr class="memdesc:a0447a45606db0e53ae9d32801e050a06"><td class="mdescLeft">&#160;</td><td class="mdescRight">Empty constructor. <br /></td></tr>
<tr class="separator:a0447a45606db0e53ae9d32801e050a06"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1bc24a1809c4d021da97f89fa143b19f"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a1bc24a1809c4d021da97f89fa143b19f">TIGLApiVertex</a> (IdType key, DataType data, AlgDataType alg)</td></tr>
<tr class="memdesc:a1bc24a1809c4d021da97f89fa143b19f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded constructor.  <a href="#a1bc24a1809c4d021da97f89fa143b19f">More...</a><br /></td></tr>
<tr class="separator:a1bc24a1809c4d021da97f89fa143b19f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aadba7f3040f667e8c3b9de7964040b44"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aadba7f3040f667e8c3b9de7964040b44"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#aadba7f3040f667e8c3b9de7964040b44">~TIGLApiVertex</a> ()</td></tr>
<tr class="memdesc:aadba7f3040f667e8c3b9de7964040b44"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor. <br /></td></tr>
<tr class="separator:aadba7f3040f667e8c3b9de7964040b44"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9d40d2434e907fbb54a135be1d9090d3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a9d40d2434e907fbb54a135be1d9090d3">setParams</a> (IdType key, DataType data, AlgDataType alg)</td></tr>
<tr class="memdesc:a9d40d2434e907fbb54a135be1d9090d3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the fields of the vertex.  <a href="#a9d40d2434e907fbb54a135be1d9090d3">More...</a><br /></td></tr>
<tr class="separator:a9d40d2434e907fbb54a135be1d9090d3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adbaa2555fe812c8660c9a5414e9bac75"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adbaa2555fe812c8660c9a5414e9bac75"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#adbaa2555fe812c8660c9a5414e9bac75">vote_to_halt</a> ()</td></tr>
<tr class="memdesc:adbaa2555fe812c8660c9a5414e9bac75"><td class="mdescLeft">&#160;</td><td class="mdescRight">Deactivates the vertex. <br /></td></tr>
<tr class="separator:adbaa2555fe812c8660c9a5414e9bac75"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a02f1b2d5de3ae2978c813e827180f21b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a02f1b2d5de3ae2978c813e827180f21b">isActive</a> ()</td></tr>
<tr class="memdesc:a02f1b2d5de3ae2978c813e827180f21b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns active status.  <a href="#a02f1b2d5de3ae2978c813e827180f21b">More...</a><br /></td></tr>
<tr class="separator:a02f1b2d5de3ae2978c813e827180f21b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9418ab15c2cd6275b146186dac667f0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae9418ab15c2cd6275b146186dac667f0"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#ae9418ab15c2cd6275b146186dac667f0">isActiveWithNoMessage</a> ()</td></tr>
<tr class="memdesc:ae9418ab15c2cd6275b146186dac667f0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if the vertex stays active even without messages. <br /></td></tr>
<tr class="separator:ae9418ab15c2cd6275b146186dac667f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5bc44315862e8648664fb515fb244230"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5bc44315862e8648664fb515fb244230"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a5bc44315862e8648664fb515fb244230">clear</a> ()</td></tr>
<tr class="memdesc:a5bc44315862e8648664fb515fb244230"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clears all edges and deactivates the vertex. <br /></td></tr>
<tr class="separator:a5bc44315862e8648664fb515fb244230"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ca961611ed7a646ea8dc7847c31b20d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2ca961611ed7a646ea8dc7847c31b20d"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a2ca961611ed7a646ea8dc7847c31b20d">canReactivate</a> ()</td></tr>
<tr class="memdesc:a2ca961611ed7a646ea8dc7847c31b20d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if the vertex can be reactivated by new messages. <br /></td></tr>
<tr class="separator:a2ca961611ed7a646ea8dc7847c31b20d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a048dcbd05a01f8dab31fd8523f6723d8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a048dcbd05a01f8dab31fd8523f6723d8"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a048dcbd05a01f8dab31fd8523f6723d8">activate</a> ()</td></tr>
<tr class="memdesc:a048dcbd05a01f8dab31fd8523f6723d8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Activates the vertex. <br /></td></tr>
<tr class="separator:a048dcbd05a01f8dab31fd8523f6723d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a509bac1afaa2f2141616ae8fc06c0ddd"><td class="memTemplParams" colspan="2">template&lt;typename ALLOCATOR_TYPE &gt; </td></tr>
<tr class="memitem:a509bac1afaa2f2141616ae8fc06c0ddd"><td class="memTemplItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a509bac1afaa2f2141616ae8fc06c0ddd">compute</a> (MESSAGE_BUF_TYPE *pIn, vector&lt; MESSAGE_TYPE, ALLOCATOR_TYPE &gt; *pOut, uint_fast32_t numMessages)</td></tr>
<tr class="memdesc:a509bac1afaa2f2141616ae8fc06c0ddd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual core compute function.  <a href="#a509bac1afaa2f2141616ae8fc06c0ddd">More...</a><br /></td></tr>
<tr class="separator:a509bac1afaa2f2141616ae8fc06c0ddd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a846155817024d5eb7c732a3989b639f1"><td class="memTemplParams" colspan="2">template&lt;typename ALLOCATOR_TYPE &gt; </td></tr>
<tr class="memitem:a846155817024d5eb7c732a3989b639f1"><td class="memTemplItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a846155817024d5eb7c732a3989b639f1">init</a> (INIT_TYPE *initParams, vector&lt; MESSAGE_TYPE, ALLOCATOR_TYPE &gt; *pOut)</td></tr>
<tr class="memdesc:a846155817024d5eb7c732a3989b639f1"><td class="mdescLeft">&#160;</td><td class="mdescRight">virtual core init function. Here it is an empty function that must be overridden by customized vertex definition for the different graph algorithms  <a href="#a846155817024d5eb7c732a3989b639f1">More...</a><br /></td></tr>
<tr class="separator:a846155817024d5eb7c732a3989b639f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a43502dad7f920fcf45f13710457ffb05"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a43502dad7f920fcf45f13710457ffb05"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a43502dad7f920fcf45f13710457ffb05">getMessageBufSize</a> ()</td></tr>
<tr class="memdesc:a43502dad7f920fcf45f13710457ffb05"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the size of message buffers. <br /></td></tr>
<tr class="separator:a43502dad7f920fcf45f13710457ffb05"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa9723e50976503ca2ce8f5a0947a04c7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa9723e50976503ca2ce8f5a0947a04c7"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#aa9723e50976503ca2ce8f5a0947a04c7">setAggPtr</a> (<a class="el" href="classTIGLContainersAggregate.html">AGGREGATE_TYPE</a> *infoPtr)</td></tr>
<tr class="memdesc:aa9723e50976503ca2ce8f5a0947a04c7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a pointer to the aggregate information object. <br /></td></tr>
<tr class="separator:aa9723e50976503ca2ce8f5a0947a04c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classTIGLContainersVertexBase"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classTIGLContainersVertexBase')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;</a></td></tr>
<tr class="memitem:ab12e0c19620ff872c8b793ff001f022b inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#ab12e0c19620ff872c8b793ff001f022b">TIGLContainersVertexBase</a> (IdType key)</td></tr>
<tr class="memdesc:ab12e0c19620ff872c8b793ff001f022b inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#ab12e0c19620ff872c8b793ff001f022b">More...</a><br /></td></tr>
<tr class="separator:ab12e0c19620ff872c8b793ff001f022b inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0c2b931b7f439a72da6baaadbb6f753d inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a0c2b931b7f439a72da6baaadbb6f753d">TIGLContainersVertexBase</a> (IdType key, DataType data, AlgDataType alg)</td></tr>
<tr class="memdesc:a0c2b931b7f439a72da6baaadbb6f753d inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded constructor.  <a href="#a0c2b931b7f439a72da6baaadbb6f753d">More...</a><br /></td></tr>
<tr class="separator:a0c2b931b7f439a72da6baaadbb6f753d inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3887a721638627b063306724ad8cf22b inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3887a721638627b063306724ad8cf22b"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a3887a721638627b063306724ad8cf22b">TIGLContainersVertexBase</a> ()</td></tr>
<tr class="memdesc:a3887a721638627b063306724ad8cf22b inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded empty constructor. <br /></td></tr>
<tr class="separator:a3887a721638627b063306724ad8cf22b inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a260b170afbb1f183b7d6247a148fea83 inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a260b170afbb1f183b7d6247a148fea83"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a260b170afbb1f183b7d6247a148fea83">operator&lt;</a> (const <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt; &amp;rhs) const </td></tr>
<tr class="memdesc:a260b170afbb1f183b7d6247a148fea83 inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for list ordering. <br /></td></tr>
<tr class="separator:a260b170afbb1f183b7d6247a148fea83 inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac1f818aadbfdd77acf6eb5974339b582 inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac1f818aadbfdd77acf6eb5974339b582"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#ac1f818aadbfdd77acf6eb5974339b582">operator==</a> (const <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt; &amp;rhs) const </td></tr>
<tr class="memdesc:ac1f818aadbfdd77acf6eb5974339b582 inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded equal operator for list ordering. <br /></td></tr>
<tr class="separator:ac1f818aadbfdd77acf6eb5974339b582 inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7cc87d2b4157b298460486dab71dfb44 inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a7cc87d2b4157b298460486dab71dfb44">addEdge</a> (EdgeType &amp;x)</td></tr>
<tr class="memdesc:a7cc87d2b4157b298460486dab71dfb44 inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds output edge.  <a href="#a7cc87d2b4157b298460486dab71dfb44">More...</a><br /></td></tr>
<tr class="separator:a7cc87d2b4157b298460486dab71dfb44 inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2d6b5c292809922673ceb6fdb188b6b3 inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a2d6b5c292809922673ceb6fdb188b6b3">addEdge</a> (ID_TYPE &amp;target)</td></tr>
<tr class="memdesc:a2d6b5c292809922673ceb6fdb188b6b3 inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds output edge (overloaded function)  <a href="#a2d6b5c292809922673ceb6fdb188b6b3">More...</a><br /></td></tr>
<tr class="separator:a2d6b5c292809922673ceb6fdb188b6b3 inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9dc66486575edee5b2901b6fa01b370 inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#ae9dc66486575edee5b2901b6fa01b370">addEdge</a> (OUT_EDGE_BUF &amp;x)</td></tr>
<tr class="memdesc:ae9dc66486575edee5b2901b6fa01b370 inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds multiple ouput edges.  <a href="#ae9dc66486575edee5b2901b6fa01b370">More...</a><br /></td></tr>
<tr class="separator:ae9dc66486575edee5b2901b6fa01b370 inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a355bc674650678249bd53adc12f1cb4d inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a355bc674650678249bd53adc12f1cb4d">removeEdge</a> (IdType &amp;target)</td></tr>
<tr class="memdesc:a355bc674650678249bd53adc12f1cb4d inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes an output edge identified by target node.  <a href="#a355bc674650678249bd53adc12f1cb4d">More...</a><br /></td></tr>
<tr class="separator:a355bc674650678249bd53adc12f1cb4d inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae54bd25069156c7ff89a9907f2167b24 inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae54bd25069156c7ff89a9907f2167b24"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#ae54bd25069156c7ff89a9907f2167b24">clearEdges</a> ()</td></tr>
<tr class="memdesc:ae54bd25069156c7ff89a9907f2167b24 inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clears all output edges. <br /></td></tr>
<tr class="separator:ae54bd25069156c7ff89a9907f2167b24 inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8aa2da8ab2f06ff33fb499ee42b228ce inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8aa2da8ab2f06ff33fb499ee42b228ce"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a8aa2da8ab2f06ff33fb499ee42b228ce">getNumOutEdges</a> ()</td></tr>
<tr class="memdesc:a8aa2da8ab2f06ff33fb499ee42b228ce inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the total number of output edges. <br /></td></tr>
<tr class="separator:a8aa2da8ab2f06ff33fb499ee42b228ce inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77 inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77">getNumDifferentNbr</a> ()</td></tr>
<tr class="memdesc:a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77 inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of neigbors excluding self (i.e., ignoring self cycles) <br /></td></tr>
<tr class="separator:a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77 inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd0b2f0822224ebb4ee9b2d9b6ae7ba0 inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#afd0b2f0822224ebb4ee9b2d9b6ae7ba0">getChildren</a> (vector&lt; IdType &gt; &amp;vectChildren)</td></tr>
<tr class="memdesc:afd0b2f0822224ebb4ee9b2d9b6ae7ba0 inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the vertex id of all children.  <a href="#afd0b2f0822224ebb4ee9b2d9b6ae7ba0">More...</a><br /></td></tr>
<tr class="separator:afd0b2f0822224ebb4ee9b2d9b6ae7ba0 inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b9a5ee6ceed8269cfde06116fa4fb30 inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a6b9a5ee6ceed8269cfde06116fa4fb30">isConnected</a> (IdType node)</td></tr>
<tr class="memdesc:a6b9a5ee6ceed8269cfde06116fa4fb30 inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if a given node is connected to the current node.  <a href="#a6b9a5ee6ceed8269cfde06116fa4fb30">More...</a><br /></td></tr>
<tr class="separator:a6b9a5ee6ceed8269cfde06116fa4fb30 inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a776920aff39617337c8c0d11100fa948 inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a776920aff39617337c8c0d11100fa948"></a>
DataType &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a776920aff39617337c8c0d11100fa948">get_value</a> ()</td></tr>
<tr class="memdesc:a776920aff39617337c8c0d11100fa948 inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the vertex data field. <br /></td></tr>
<tr class="separator:a776920aff39617337c8c0d11100fa948 inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a782c440fc6c8ae87291f142239260091 inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a782c440fc6c8ae87291f142239260091"></a>
AlgDataType &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a782c440fc6c8ae87291f142239260091">getAlgData</a> ()</td></tr>
<tr class="memdesc:a782c440fc6c8ae87291f142239260091 inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the algorithm data. <br /></td></tr>
<tr class="separator:a782c440fc6c8ae87291f142239260091 inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c2f4752f5f1df26b608ddc6400777aa inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5c2f4752f5f1df26b608ddc6400777aa"></a>
IdType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a5c2f4752f5f1df26b608ddc6400777aa">getId</a> ()</td></tr>
<tr class="memdesc:a5c2f4752f5f1df26b608ddc6400777aa inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the vertex id. <br /></td></tr>
<tr class="separator:a5c2f4752f5f1df26b608ddc6400777aa inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a077ed089a01250a2d15fc5acc7e3aaf6 inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a077ed089a01250a2d15fc5acc7e3aaf6"></a>
OUT_EDGE_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a077ed089a01250a2d15fc5acc7e3aaf6">getBeginOutEdgeIterator</a> ()</td></tr>
<tr class="memdesc:a077ed089a01250a2d15fc5acc7e3aaf6 inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns an iterator to the start of the outEdges buffer. <br /></td></tr>
<tr class="separator:a077ed089a01250a2d15fc5acc7e3aaf6 inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3af614e7143fb092f6a3115514de319b inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3af614e7143fb092f6a3115514de319b"></a>
OUT_EDGE_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a3af614e7143fb092f6a3115514de319b">getEndOutEdgeIterator</a> ()</td></tr>
<tr class="memdesc:a3af614e7143fb092f6a3115514de319b inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns an iterator to the last edge of the outEdges buffer. <br /></td></tr>
<tr class="separator:a3af614e7143fb092f6a3115514de319b inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb1a96d0d3ccc33e97c1b84af0a045d7 inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top">OUT_EDGE_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#afb1a96d0d3ccc33e97c1b84af0a045d7">get_edge</a> (ID_TYPE target)</td></tr>
<tr class="memdesc:afb1a96d0d3ccc33e97c1b84af0a045d7 inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns an iterator to the output edge with a given target.  <a href="#afb1a96d0d3ccc33e97c1b84af0a045d7">More...</a><br /></td></tr>
<tr class="separator:afb1a96d0d3ccc33e97c1b84af0a045d7 inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af0521f19891d34cc1dfba07ec5bd83cd inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#af0521f19891d34cc1dfba07ec5bd83cd">isBiVertex</a> ()</td></tr>
<tr class="memdesc:af0521f19891d34cc1dfba07ec5bd83cd inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if the vertex type is <a class="el" href="classTIGLContainersBiVertex.html" title="Core vertex class with input and output edge buffers. ">TIGLContainersBiVertex</a>.  <a href="#af0521f19891d34cc1dfba07ec5bd83cd">More...</a><br /></td></tr>
<tr class="separator:af0521f19891d34cc1dfba07ec5bd83cd inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ace8a3901abb1f925cd442ff24200b45f inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ace8a3901abb1f925cd442ff24200b45f"></a>
virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#ace8a3901abb1f925cd442ff24200b45f">compute</a> (void *pIn=0, void *pOut=0)</td></tr>
<tr class="memdesc:ace8a3901abb1f925cd442ff24200b45f inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Core compute function: trivial realization in the core class. This function is overriden by the algorithm class. <br /></td></tr>
<tr class="separator:ace8a3901abb1f925cd442ff24200b45f inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a53510bd15bbce08013705a779d3b191a inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a53510bd15bbce08013705a779d3b191a"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a53510bd15bbce08013705a779d3b191a">init</a> ()</td></tr>
<tr class="memdesc:a53510bd15bbce08013705a779d3b191a inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Core init function: trivial realization in the core class. This function is overriden by the algorithm class. <br /></td></tr>
<tr class="separator:a53510bd15bbce08013705a779d3b191a inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afcd5a44e577f8d3f69b6fb0b5f4fc2ec inherit pub_methods_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="afcd5a44e577f8d3f69b6fb0b5f4fc2ec"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#afcd5a44e577f8d3f69b6fb0b5f4fc2ec">getEdgesSize</a> ()</td></tr>
<tr class="memdesc:afcd5a44e577f8d3f69b6fb0b5f4fc2ec inherit pub_methods_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns memory usage for edges. <br /></td></tr>
<tr class="separator:afcd5a44e577f8d3f69b6fb0b5f4fc2ec inherit pub_methods_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a7f130ee572059d53540d2fe45012803a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7f130ee572059d53540d2fe45012803a"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a7f130ee572059d53540d2fe45012803a">flagActive</a></td></tr>
<tr class="memdesc:a7f130ee572059d53540d2fe45012803a"><td class="mdescLeft">&#160;</td><td class="mdescRight">active flag <br /></td></tr>
<tr class="separator:a7f130ee572059d53540d2fe45012803a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classTIGLContainersVertexBase"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classTIGLContainersVertexBase')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;</a></td></tr>
<tr class="memitem:a3f6edf01d8830e0b5b8ad74549eeb085 inherit pro_attribs_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3f6edf01d8830e0b5b8ad74549eeb085"></a>
IdType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a3f6edf01d8830e0b5b8ad74549eeb085">id</a></td></tr>
<tr class="memdesc:a3f6edf01d8830e0b5b8ad74549eeb085 inherit pro_attribs_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">unique vertex ID <br /></td></tr>
<tr class="separator:a3f6edf01d8830e0b5b8ad74549eeb085 inherit pro_attribs_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a42054ed48c73a733e99f3ef80698e50b inherit pro_attribs_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a42054ed48c73a733e99f3ef80698e50b"></a>
DataType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a42054ed48c73a733e99f3ef80698e50b">vertexData</a></td></tr>
<tr class="memdesc:a42054ed48c73a733e99f3ef80698e50b inherit pro_attribs_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">associated generic data <br /></td></tr>
<tr class="separator:a42054ed48c73a733e99f3ef80698e50b inherit pro_attribs_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac36b610433331bb36b1c05a1fa942418 inherit pro_attribs_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac36b610433331bb36b1c05a1fa942418"></a>
AlgDataType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">algData</a></td></tr>
<tr class="memdesc:ac36b610433331bb36b1c05a1fa942418 inherit pro_attribs_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">Algorithm-specific data. <br /></td></tr>
<tr class="separator:ac36b610433331bb36b1c05a1fa942418 inherit pro_attribs_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e0e018b11f1fbe310789c332efed1b9 inherit pro_attribs_classTIGLContainersVertexBase"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8e0e018b11f1fbe310789c332efed1b9"></a>
OUT_EDGE_BUF&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a8e0e018b11f1fbe310789c332efed1b9">outEdges</a></td></tr>
<tr class="memdesc:a8e0e018b11f1fbe310789c332efed1b9 inherit pro_attribs_classTIGLContainersVertexBase"><td class="mdescLeft">&#160;</td><td class="mdescRight">output edge buffer <br /></td></tr>
<tr class="separator:a8e0e018b11f1fbe310789c332efed1b9 inherit pro_attribs_classTIGLContainersVertexBase"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-static-attribs"></a>
Static Protected Attributes</h2></td></tr>
<tr class="memitem:a59c1819f355b9297fd943e02de1c9d1f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a59c1819f355b9297fd943e02de1c9d1f"></a>
static <a class="el" href="classTIGLContainersAggregate.html">AGGREGATE_TYPE</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a59c1819f355b9297fd943e02de1c9d1f">aggregateInfoPtr</a></td></tr>
<tr class="memdesc:a59c1819f355b9297fd943e02de1c9d1f"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to the aggregate information <br /></td></tr>
<tr class="separator:a59c1819f355b9297fd943e02de1c9d1f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abf0b30555edcb496a6605e442066eb11"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abf0b30555edcb496a6605e442066eb11"></a>
static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#abf0b30555edcb496a6605e442066eb11">activeWithNoMessage</a></td></tr>
<tr class="memdesc:abf0b30555edcb496a6605e442066eb11"><td class="mdescLeft">&#160;</td><td class="mdescRight">a flag when true the vertex is processed even with no message, if false it is processed only if there are messages <br /></td></tr>
<tr class="separator:abf0b30555edcb496a6605e442066eb11"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5f97f5c472444d212bf6ddfd217032e2"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5f97f5c472444d212bf6ddfd217032e2"></a>
static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiVertex.html#a5f97f5c472444d212bf6ddfd217032e2">reactivateFlag</a></td></tr>
<tr class="memdesc:a5f97f5c472444d212bf6ddfd217032e2"><td class="mdescLeft">&#160;</td><td class="mdescRight">a flag when true the vertex can be reactivated by new messages, otherwise it never wake up once becomes inactive <br /></td></tr>
<tr class="separator:a5f97f5c472444d212bf6ddfd217032e2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename InitType, typename IdType = uint_fast32_t, typename MessageType = DblMessage&gt;<br />
class TIGLApiVertex&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;</h3>

<p>Core vertex class for the TIGL Engine (with only output edge buffer). </p>
<p>It inherits the core vertex class and add messaging capabilities. This class is inherited by customized classes for different graph algorithms. It is a template class that is parameterized by the following parameters </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">DataType</td><td>the vertex data field, </td></tr>
    <tr><td class="paramname">AlgDataType</td><td>the algorithm data field, </td></tr>
    <tr><td class="paramname">EdgeType</td><td>the edge type, </td></tr>
    <tr><td class="paramname">InitType</td><td>the type of initial data for the graph algorithm, </td></tr>
    <tr><td class="paramname">IdType</td><td>the type of id for the vertices </td></tr>
    <tr><td class="paramname">the</td><td>message type. </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a396f16eeb0b3b320cb8486f96fb84b87"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType , typename AlgDataType , typename EdgeType , typename InitType , typename IdType, typename MessageType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTIGLApiVertex.html">TIGLApiVertex</a>&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;::<a class="el" href="classTIGLApiVertex.html">TIGLApiVertex</a> </td>
          <td>(</td>
          <td class="paramtype">IdType&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>noMessageFlag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>inFlagReactivate</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor setting parameters. </p>
<p>The data and algorithm attributes are not assigned </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>vertex id </td></tr>
    <tr><td class="paramname">noMessageFlag</td><td>flag to set activeWithNoMessage </td></tr>
    <tr><td class="paramname">inFlagReactivate</td><td>flag to set reactivateFlag </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0c21ec2a0ed8a52afb7617792c919d1d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType , typename InitType , typename IdType, typename MessageType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTIGLApiVertex.html">TIGLApiVertex</a>&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;::<a class="el" href="classTIGLApiVertex.html">TIGLApiVertex</a> </td>
          <td>(</td>
          <td class="paramtype">IdType&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">DataType&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">AlgDataType&#160;</td>
          <td class="paramname"><em>alg</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>noMessageFlag</em> = <code>false</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>inFlagReactivate</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded constructor with more detailed setting parameters. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>vertex id </td></tr>
    <tr><td class="paramname">data</td><td>initial value of <a class="el" href="classTIGLContainersVertexBase.html#a42054ed48c73a733e99f3ef80698e50b">vertexData </a> field </td></tr>
    <tr><td class="paramname">alg</td><td>initial value for <a class="el" href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">algData </a> field </td></tr>
    <tr><td class="paramname">noMessageFlag</td><td>flag to set activeWithNoMessage </td></tr>
    <tr><td class="paramname">inFlagReactivate</td><td>flag to set reactivateFlag </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ad473daccad90e41fa3b6475ac3a2a481"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType , typename InitType , typename IdType, typename MessageType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTIGLApiVertex.html">TIGLApiVertex</a>&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;::<a class="el" href="classTIGLApiVertex.html">TIGLApiVertex</a> </td>
          <td>(</td>
          <td class="paramtype">IdType&#160;</td>
          <td class="paramname"><em>key</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded constructor with less detailed setting parameters. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>vertex id </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1bc24a1809c4d021da97f89fa143b19f"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType , typename InitType , typename IdType, typename MessageType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTIGLApiVertex.html">TIGLApiVertex</a>&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;::<a class="el" href="classTIGLApiVertex.html">TIGLApiVertex</a> </td>
          <td>(</td>
          <td class="paramtype">IdType&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">DataType&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">AlgDataType&#160;</td>
          <td class="paramname"><em>alg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>vertex id </td></tr>
    <tr><td class="paramname">data</td><td>initial value of <a class="el" href="classTIGLContainersVertexBase.html#a42054ed48c73a733e99f3ef80698e50b">vertexData </a> field </td></tr>
    <tr><td class="paramname">alg</td><td>initial value for <a class="el" href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">algData </a> field </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a509bac1afaa2f2141616ae8fc06c0ddd"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType , typename AlgDataType , typename EdgeType , typename InitType , typename IdType , typename MessageType &gt; </div>
<div class="memtemplate">
template&lt;typename ALLOCATOR_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLApiVertex.html">TIGLApiVertex</a>&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;::compute </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_BUF_TYPE *&#160;</td>
          <td class="paramname"><em>pIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vector&lt; MESSAGE_TYPE, ALLOCATOR_TYPE &gt; *&#160;</td>
          <td class="paramname"><em>pOut</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numMessages</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Virtual core compute function. </p>
<p>It is an empty function that must be overridden by customized vertex definition for the different graph algorithms </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pIn</td><td>pointer to the input message buffer </td></tr>
    <tr><td class="paramname">pOut</td><td>pointer to the output message buffer </td></tr>
    <tr><td class="paramname">numMessages</td><td>the number of input data messages </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of output data messages </dd></dl>

</div>
</div>
<a class="anchor" id="a846155817024d5eb7c732a3989b639f1"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType , typename AlgDataType , typename EdgeType , typename InitType , typename IdType , typename MessageType &gt; </div>
<div class="memtemplate">
template&lt;typename ALLOCATOR_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLApiVertex.html">TIGLApiVertex</a>&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;::init </td>
          <td>(</td>
          <td class="paramtype">INIT_TYPE *&#160;</td>
          <td class="paramname"><em>initParams</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vector&lt; MESSAGE_TYPE, ALLOCATOR_TYPE &gt; *&#160;</td>
          <td class="paramname"><em>pOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>virtual core init function. Here it is an empty function that must be overridden by customized vertex definition for the different graph algorithms </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">initParams</td><td>pointer to the initialization parameters </td></tr>
    <tr><td class="paramname">pOut</td><td>pointer to the output message buffer </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of output data messages </dd></dl>

</div>
</div>
<a class="anchor" id="a02f1b2d5de3ae2978c813e827180f21b"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType , typename AlgDataType , typename EdgeType , typename InitType , typename IdType , typename MessageType &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLApiVertex.html">TIGLApiVertex</a>&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;::isActive </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns active status. </p>
<dl class="section return"><dt>Returns</dt><dd>true if active, false if inactive </dd></dl>

</div>
</div>
<a class="anchor" id="a9d40d2434e907fbb54a135be1d9090d3"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType , typename InitType , typename IdType, typename MessageType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLApiVertex.html">TIGLApiVertex</a>&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;::setParams </td>
          <td>(</td>
          <td class="paramtype">IdType&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">DataType&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">AlgDataType&#160;</td>
          <td class="paramname"><em>alg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sets the fields of the vertex. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>vertex id </td></tr>
    <tr><td class="paramname">data</td><td>value for <a class="el" href="classTIGLContainersVertexBase.html#a42054ed48c73a733e99f3ef80698e50b">vertexData </a> field </td></tr>
    <tr><td class="paramname">alg</td><td>value for <a class="el" href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">algData </a> field </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="tiglApiVertex_8hpp_source.html">tiglApiVertex.hpp</a></li>
<li><a class="el" href="tiglImplementationVertex_8hpp_source.html">tiglImplementationVertex.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:56 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
